#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>

// Global defines

#define SCREEN_WIDTH_0 256
#define SCREEN_WIDTH_1 320
#define SCREEN_WIDTH_2 384
#define SCREEN_WIDTH_3 512
#define SCREEN_WIDTH_4 640

#define DISPLAY_PAL

#ifdef DISPLAY_PAL
#define SCREEN_HEIGHT_0 256
#define SCREEN_HEIGHT_1 512
#else
#define DISPLAY_NTSC
#define SCREEN_HEIGHT_0 240
#define SCREEN_HEIGHT_1 480
#endif

#define SCREEN_WIDTH SCREEN_WIDTH_3
#define SCREEN_HEIGHT SCREEN_HEIGHT_0
#define SCREEN_X_OFFSET 0
#define SCREEN_Y_OFFSET 0
//#define SCREEN_X_OFFSET 30
//#define SCREEN_Y_OFFSET 24

#define OFFSCREENBUFFER_X 512
#define OFFSCREENBUFFER_Y 0

#ifndef BIT
#define BIT(n) (1 << (n))
#endif

#define SPRITE_ROT_SCALE_OFF BIT(27)
#define SPRITE_BRIGHTNESS_OFF BIT(6)
#define SPRITE_TRANSPARENCY_ON BIT(30)
#define SPRITE_DISPLAY_OFF BIT(31)
#define SPRITE_COLOUR_MODE(mode) (((mode) & 3) << 24)
#define SPRITE_TRANSPARENCY_MODE(mode) ((mode) << 28)

//----------- GPU packet space ------------------

#define PACKETMAX       4096//2048            /* Max GPU packets */
#define PACKETMAX2	(PACKETMAX*24)

#define MAIN_OT_LENGTH		 9
#define GROUND_OT_LENGTH     7
#define REFLECTION_OT_LENGTH 9

#ifdef SOURCE_DISPLAY_C
#define SOURCE_EXTERN_ON
#else
#define SOURCE_EXTERN_ON extern
#endif
SOURCE_EXTERN_ON GsOT mainOT[2];                                             // OT Handlers
SOURCE_EXTERN_ON GsOT groundOT[2];                                             // OT Handlers
SOURCE_EXTERN_ON GsOT reflectionOT[2];                                       // OT Handlers

SOURCE_EXTERN_ON GsOT_TAG mainOTTags[2][1<<MAIN_OT_LENGTH];
SOURCE_EXTERN_ON GsOT_TAG groundOTTags[2][1<<GROUND_OT_LENGTH];
SOURCE_EXTERN_ON GsOT_TAG reflectionOTTags[2][1<<REFLECTION_OT_LENGTH];

SOURCE_EXTERN_ON PACKET PacketArea[2][PACKETMAX2];        // GPU Packet area

SOURCE_EXTERN_ON short g_ScreenBufferNum;          // Double Buffering Buffer Num

// Prototypes

void initialiseDisplay(void);
void initNewDraw(void);
void completeDraw(void);
void loadTIM(u_long *, RECT *, RECT *, GsIMAGE *, GsSPRITE *);
void fadeOut(void);
void moveSky(int x, int z);
