;//
;//	"SHRDTRI.ASM" - Sample Code
;//
;//	Copyright (C) 1998  Sony Computer Entertainment Europe
;//	All rights Reserved
;//

;// This file contains an HMD driver for shared triangles. No clipping is
;// performed.
;// Assemble with ASMPSX.

	include gtereg.h
	include inline_a.h

	XDEF	GsU_01040049

	XREF	GsOUT_PACKET_P
	XREF	reflectionMode

	SECTION	.text

	OPT at-,h-


;//************************************************************************
;//* (Back-Facing) Shared Non-lit Flat Texture Triangle
;//*
;//*       a0: (GsARGUNIT_SHARED *)sp
;//*
;//*       typedef struct {
;//*               u_long          *primp;         // 0(a0)
;//*               GsOT            *tagp;          // 4(a0)
;//*               int             shift;          // 8(a0)
;//*               int             offset;         // 12(a0)
;//*               PACKET          *out_packetp;   // 16(a0)
;//*               u_long          *primtop;       // 20(a0)
;//*               SVECTOR         *vertop;        // 24(a0)
;//*               GsWORKUNIT      *vertop2;       // 28(a0)
;//*               SVECTOR         *nortop;        // 32(a0)
;//*               SVECTOR         *nortop2;       // 36(a0)
;//*       }       GsARGUNIT_SHARED;
;//*       num:                            // (*primtop) >> 16
;//*************************************************************************

FLIPSTATUS equs "s0"

GsU_01040049:
	subu sp,1*4
	sw	s0, 0(sp)			;// Save
	lw	FLIPSTATUS,reflectionMode



	lw	t0,0(a0)			;// t0: primp
	lw	t1,16(a0)			;// t1: out_packetp
	lhu	t2,2(t0)			;// t2: num
	lw	t3,4(t0)			;// t3: POLY IDX
	lw	t4,20(a0)			;// t4: primtop
	sll	t3,t3,2				;// t3: t3*4
	beq	t2,zero,SNFT3_10	;// if (num==0) goto SNFT3_10
	addu	t7,t4,t3		;// t7: &primtop[POLY_IDX]

	lw	t9,4(a0)			;// t9: tagp
	lw	t6,12(a0)			;// t6: offset
	lw	a3,4(t9)			;// a3: otp->org
	lw	t5,28(a0)			;// t5: vertop2
	lw	t9,8(a0)			;// t9: shift

SNFT3_0:
	lw	a1,12(t7)			;// a1: Vertex0,uv2
	lw	a2,16(t7)			;// a2: Vertex1,Vertex2

	srl	v0,a1,16			;// v0: Vertex0
	sll	v0,v0,3				;// v0: Vertex0*8
	addu	t3,v0,t5		;// t3: vertop2[Vertex0]
	lw	v0,4(t3)			;// v0: p,otz
	li	t0,-1				;// t8: 0xffffffff

	beq	v0,t0,SNFT3_9		;// if(otz==0xffffffff) goto SNFT3_9(clip)
	nop
	mtc2	v0,C2_SZ0		;// v0	-> C2_SZ0
	nop

	sll	v0,a2,16			;// v0: Vertex1
	srl	v0,v0,13			;// v0: Vertex1*8
	addu	t4,v0,t5		;// t4: vertop2[Vertex1]
	lw	v0,4(t4)			;// v0: p,otz
	nop

	beq	v0,t0,SNFT3_9		;// if(otz==0xffffffff) goto SNFT3_9(clip)
	nop
	mtc2	v0,C2_SZ1		;// v0	-> C2_SZ1
	nop

	srl	v0,a2,16			;// v0: Vertex2
	sll	v0,v0,3				;// v0: Vertex2*8
	addu	v1,v0,t5		;// v1: vertop2[Vertex2]
	lw	v0,4(v1)			;// v0: p,otz
	nop

	beq	v0,t0,SNFT3_9		;// if(otz==0xffffffff) goto SNFT3_9(clip)
	nop
	mtc2	v0,C2_SZ2		;// v0	-> C2_SZ2
	nop

	lw	v0,0(t3)			;// v0: vx0,vy0
	lw	t0,0(t4)			;// t0: vx1,vy1
	lw	t3,0(v1)			;// t3: vx2,vy2
	mtc2	v0,C2_SXY0		;// vx0,vy0	-> C2_SXY0
	mtc2	t0,C2_SXY1		;// vx1,vy1	-> C2_SXY1
	mtc2	t3,C2_SXY2		;// vx2,vy2	-> C2_SXY2
	nop
	nop

	;//================================================================
	NCLIP
	;//================================================================

	sw	v0,8(t1)			;// v0	-> p->x0,y0
	sw	t0,16(t1)			;// v1	-> p->x1,y1
	sw	t3,24(t1)			;// t0	-> p->x2,y2

	mfc2	v0,C2_MAC0		;// v0: C2_MAC0
	beqz	FLIPSTATUS,FLIP_CLIP
	nop
	neg		v0
FLIP_CLIP:
	blez	v0,SNFT3_9		;// if (opz <= 0) goto SNFT3_9
	nop

	;//================================================================
	AVSZ3
	;//================================================================

	lw	v0,0(t7)			;// v0: r0,g0,b0,code
	lw	t0,4(t7)			;// t0: uv0,cba

	beqz FLIPSTATUS,NODARKEN
	nop
	li	v0,0x24202020		;// The colour 32 for R,G and B
NODARKEN:

	lw	t3,8(t7)			;// t3: uv1,tsb
	sw	v0,4(t1)			;// rgbcd	-> p->r0,g0,b0,code
	sw	t0,12(t1)			;// t0	-> p->uv0,cba
	sw	t3,20(t1)			;// t3	-> p->uv1,tsb
	sw	a1,28(t1)			;// a1	-> p->uv2

	mfc2	t4,C2_OTZ		;// t4: otz
	nop

	subu	t4,t4,t6		;// sz = sz(otz)-otp->offset
	srl	t4,t4,t9			;// sz>>shift
	and	t4,t4,0x0ffff		;// mask
	sll	t4,t4,2				;// sz*4
	addu	t4,t4,a3		;// &(tagp->org[sz])
	lw	v0,0(t4)			;// table[sz].p
	li	v1,0x7000000		;// (sizeof(POLY_FT3)/4-1<<24)

	sll	t3,v0,8
	srl	t3,t3,8				;// clear(31..24) of table[sz].p
	or	v1,v1,t3			;// (table[sz].p|0x7000000)
	sw	v1,0(t1)			;// *(long*)pkt_base = v1
	xor	v1,t1,v0			;// pkt_base xor table[sz].p

	sll	t3,v1,8
	srl	v1,t3,8				;// clear (31..24)
	xor	t3,v1,v0			;// xor table[sz].p
	sw	t3,0(t4)			;// table[sz].p = pkt_base

	addu	t1,t1,32		;// out_packet++

SNFT3_9:
	subu	t2,t2,1			;// num--
	bne	t2,0,SNFT3_0		;// if(num!=0) goto SNFT3_0
	addu	t7,t7,20		;// primtop++

SNFT3_10:
	lw	v0,0(a0)			;// sp->primp
		opt at+
	sw	t1,GsOUT_PACKET_P	;//
		opt at-
	addu	v0,v0,8			;// sp->primp+2

							;//Epilogue - Restore the stack
	lw	s0, 0(sp)			;// Restore saved args
	addu	sp,1*4


	j	ra					;// return(primtop)
	nop